
{$APPTYPE GUI}{$MODE DELPHI}

program demo51;

uses
  SysUtils,windows,math,gl,glu,GOGL_Ext,GraphOGL,GOGL_3DS;

//const
 
//type
  
var 
  timer:array[1..10]of integer;
  TexSkyBox:gluint;
  CubeMap:TGLCubeMap;
  SelObj:integer = 5;
  EnableRefrlect:boolean = true;
  Model:TGL3DSModel;
  
   
//{$R *.rc}
//{$R *.res}  


procedure OpenGL_CreateList();

procedure OpenGL_Texture();
begin    
  
  SetQualityTexture2(GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR);  
  TextureLoadTGAID('sky_rocksday6.tga',TexSkyBox);
  
  SetQualityTexture2(GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR_MIPMAP_LINEAR); 
  GenCubeMapTex('positive_x.bmp','negative_x.bmp',
                'positive_y.bmp','negative_y.bmp',
				'positive_z.bmp','negative_z.bmp',CubeMap);			
  
end;
begin 

  OpenGL_Texture();
  
  Load_GL_version_1_3;   
  
  Model.LoadModel3DS(0.1,'cristallo1.3ds');  
  
end;


procedure OpenGL_Draw();

procedure OpenGL_Draw2D();
begin
 
  OpenGL_I2D(0,0,0,0);       // inizializza la grafica 2D 
  
  OpenGL_Init(120,0,0,0,0);  // reimposta la grafica 3D
  
end;
procedure OpenGL_Mouse2D();
begin
  
end;
procedure OpenGL_Keyboard();
begin
  
  if SetglKey('1')then SelObj:=0;
  if SetglKey('2')then SelObj:=1;
  if SetglKey('3')then SelObj:=2;
  if SetglKey('4')then SelObj:=3;  
  if SetglKey('5')then SelObj:=4;  
  if SetglKey('6')then SelObj:=5; 
  
  if SetglKey('R')then EnableRefrlect:=true;
  if SetglKey('N')then EnableRefrlect:=false;  
  
end;
begin
  
  glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();
 
  OpenGL_Draw2D();               // carica gli elementi per la grafica 2d 
  OpenGL_Mouse2D();              // carica i comandi del mause per la grafica 2d
  OpenGL_Keyboard();             // carica i comandi della tastiera
  
  glTranslatef(0,0,-30);        // regola l'inquadratura degli elementi nello schermo
  glRotatef(0,1,0,0); 
    
  SetglMouseMove(GL_M0,2);    
  
  PutglPointLight(GL_LIGHT0,0, 0,10,0, 0.1); 
  
  glBindTexture(GL_TEXTURE_2D,TexSkyBox);
  SkyBox(0,0,0,5);    
  
  glDisable(GL_LIGHTING);  
  
  if EnableRefrlect then
  begin
  glTexGenf(GL_S, GL_TEXTURE_GEN_MODE, GL_REFLECTION_MAP);
  glTexGenf(GL_T, GL_TEXTURE_GEN_MODE, GL_REFLECTION_MAP);
  glTexGenf(GL_R, GL_TEXTURE_GEN_MODE, GL_REFLECTION_MAP);  
  end else  
  begin
  glTexGenf(GL_S, GL_TEXTURE_GEN_MODE, GL_NORMAL_MAP);
  glTexGenf(GL_T, GL_TEXTURE_GEN_MODE, GL_NORMAL_MAP);
  glTexGenf(GL_R, GL_TEXTURE_GEN_MODE, GL_NORMAL_MAP);
  end;
  
  glEnable(GL_TEXTURE_GEN_S);
  glEnable(GL_TEXTURE_GEN_T);
  glEnable(GL_TEXTURE_GEN_R);
  glEnable(GL_TEXTURE_CUBE_MAP);

  // elementi con Cube Map
  BindCubeMapTex(CubeMap); 
  	
  CubeMapBegin(xrot,yrot);  
  case SelObj of
    0: Cubo(0,0,0, -5,-5,-5, 5,5,5, 3);
    1: Sfera(0,0,0, 8,42,42, 1);
    2: Toroide(0,0,0, 2,6, 32,32);
	4: Model.PutModel3DS;
  end;
  CubeMapEnd;  

  case SelObj of
  3: begin
       glPushMatrix;  
       glTranslatef(0,-4,0);
       glRotatef(90,-1,0,0);
       glScalef(3,3,3); 
       CubeMapBegin(xrot,yrot);  
       PutglTeapot(0,0,0, 1,32);
       CubeMapEnd;
       glPopMatrix;
    end;
  end;  

  case SelObj of  
  5: begin  
       TextureON;
       SetglNewMat(0.25,0.25,0.25, 0,0,0, 0.125,0.125,0.125, 0.25,0.25,0.25, 25);
       glPushMatrix;  
       glTranslatef(0,-5.5,0);   
       CubeMapBegin(xrot,yrot); 
       glEnable(GL_LIGHTING);  
       SetglSprite(false);
       CreateHighWater(40,256);
	   CreateWaweHW(2200,0.006,2);
       SetglSpriteOFF;   
       glDisable(GL_LIGHTING);    
       CubeMapEnd;
       glPopMatrix;
	   TextureOFF;
    end;
  end; 
  
  glDisable(GL_TEXTURE_CUBE_MAP);
  glDisable(GL_TEXTURE_GEN_S);
  glDisable(GL_TEXTURE_GEN_T);
  glDisable(GL_TEXTURE_GEN_R);
  
end;

// inizio del programma
begin

 if MessageBox(0,'Settare lo schermo intero?  ', 'Video!',MB_YESNO OR MB_ICONQUESTION) = IDNO 
  then fullscreen := false else fullscreen := true;
  
 OGLWindowSetting(ARROW,'',GENERIC,'');
 CreateOGLWindow('Texture CubeMap - 1-6/cambia elemento - R/riflesso - N/normale', 800, 600, 32, fullscreen);// si possono usare anche dei rapporti diversi da 4/3 o 16/9
 OpenGL_Init(120,0,0,0,0);			  // inizializza la grafica OpenGL(consente d'impostare il colore di sfondo e la profondit della visuale) 
 SetglRefractive();                         // imposta la rifrazione ambientale ed elimina le facce interne
 SetglLight(GL_LIGHT0,0.0,0.0,0.0,0.1);     // imposta la luce ambientale
 OpenGL_CreateList();                       // carica le liste degli oggetti (modelli composti)

 // impostare qui i valori delle variabili   

 REPEAT				     // inizio del ciclo principale

 glCLEAR(GL_COLOR_BUFFER_BIT);
 Setglmsg();

 OpenGL_Draw();             // carica gli elementi che devono essere un aggiornati sullo schermo 
 SwapBuffers(dcWindow);	    // abilita la visualizzazione grafica OpenGL

 // inserire qui eventuali dati aggiuntivi

UNTIL active = false;		// fine del ciclo principale (premere ESC per uscire)

 DeleteOGLWindow();		    // chiude la finestra
end.
